#include<avr/io.h>
#include<util/delay.h>
#include"defines.h"
#include"lcd.h"
#include"adc.h"

/*
All functions for Touchscreen handling
*/

//Initialize ADC
void adc_init(void)
{
	ADMUX=(1<<REFS0);
	ADCSRA=(1<<ADEN);
}

//Read ADC-Channel
int  adc_read(int chan)
{
	chan&=0x0F;
	ADMUX&=0xf0;
	ADMUX|=chan;   //MUX auf Kanal einstellen
	ADCSRA|=(1<<ADSC); //Umwandlung starten
	while(ADCSRA&(1<<ADSC)){} //Warten auf Ende der Umwandlung
	return ADCW; //ADC-Wert zurckgeben
}

//Is LCD touched?
int touched(void)
{
	TOUCH_PORT=0x01; //Pullup an Pin 1 an(HIGH)
	TOUCH_DDR=0x04;  //Pin 3 als Ausgang(LOW)
	_delay_ms(1);
	return (TOUCH_PIN&0x01)?0:1; //Schauen, ob Pullup-Pin1 durch Pin3 auf LOW gezogen wird -> Touch ist gedrckt, daher beide Touchebenen verbunden
}

//Read raw X
int read_x(void)
{
	TOUCH_PORT=0x04;
	TOUCH_DDR=0x0C; //PORT einstellen 
	_delay_ms(2);
	return adc_read(1);	//Rohen ADC-Wert zurckgeben
}

//Read raw Y
int read_y(void)
{
	TOUCH_PORT=0x02;
	TOUCH_DDR=0x03;  //PORT einstellen
	_delay_ms(1);
	return adc_read(2); //Rohen ADC-Wert zurckgeben
}

//Read screen X
// Sollte durch eine richtige Kalibrierung ersetzt werden... nur zum testen
int read_xval(void)
{
	long tx=read_x(); //Rohen ADC-Wert holen
	tx-=280; //Offset abziehen (muss bei jedem Display angepasst werden)
	tx*=327;
	tx/=1000; //Skalieren (muss bei jedem Display angepasst werden)
	if(tx<0){tx=0;}
	if(tx>160){tx=160;} //Wertebereich eingrenzen
	return tx;
}

//Read screen Y
// Sollte durch eine richtige Kalibrierung ersetzt werden... nur zum testen
int read_yval(void)
{
	long ty=read_y();
	ty-=295; //Offset abziehen (muss bei jedem Display angepasst werden)
	ty*=192;
	ty/=1000;  //Skalieren (muss bei jedem Display angepasst werden)
	if(ty<0){ty=0;}
	if(ty>80){ty=80;}  //Wertebereich eingrenzen
	return ty;
}
